import java.util.*;

public class DoubleBendy extends DoubleConstraint
{
	double k, z;
	Vector2D center;
	
	public DoubleBendy(PointMass a, PointMass b, Vector2D loc, double nk, double nb)
	{
		super(a,b,0);
		center = loc;
		k = nk;
		z = nb;
	}
	
	public boolean act(PhysicsEnv e)
	{
		//if (objA.bSleeping() != objB.bSleeping())
		{
			objA.wake();
			objB.wake();
		}
		Vector2D locA = e.getLoc(objA), locB = e.getLoc(objB);
		Vector2D r = locB.subtract(locA).subtract(center);
		double d = r.magnitude();
		if (d == 0)
			return false;
		r = r.scalarDiv(d);
		objB.applyForce(r.scalarMult(-k*d-z*objB.getVelocity().magnitude()));
		objA.applyForce(r.scalarMult(k*d+z*objA.getVelocity().magnitude()));
		return false;
	}
	
	public double getK()
	{
		return k;
	}
	
	public void setK(double j)
	{
		k = j;
	}
}