import java.util.*;

public class DoubleSpring extends DoubleConstraint
{
	double x, k, z;
	double b;
	
	public DoubleSpring(PointMass a, PointMass b, double nk, double x0, double nb)
	{
		super(a,b,x0);
		k = nk;
		x = x0;
		z = nb;
	}
	
	public boolean act(PhysicsEnv e)
	{
		//if (objA.bSleeping() != objB.bSleeping())
		{
			objA.wake();
			objB.wake();
		}
		Vector2D locA = e.getLoc(objA), locB = e.getLoc(objB);
		Vector2D r = locA.subtract(locB);
		double d = r.magnitude()/2;
		r = r.scalarDiv(d*2);
		
		objB.applyForce(r.scalarMult(k*(d-x)+z*objB.getVelocity().magnitude()));
		objA.applyForce(r.scalarMult(-k*(d-x)-z*objA.getVelocity().magnitude()));
		
		return false;
	}
	
	public double getK()
	{
		return k;
	}
	
	public void setK(double j)
	{
		k = j;
	}
}